#ifndef INCLUDE_H_SHELLEXECACTIONINVOKERFACTORY
#define INCLUDE_H_SHELLEXECACTIONINVOKERFACTORY

#include "ActionInvokerFactory.hpp"

class ShellExecActionInvokerFactory : public ActionInvokerFactory
{
private:
	ShellExecActionInvokerFactory( const ShellExecActionInvokerFactory& ); //<! Ȃ
	void operator=( const ShellExecActionInvokerFactory& ); //<! Ȃ

protected:
	virtual ~ShellExecActionInvokerFactory();

public:
	ShellExecActionInvokerFactory();
	virtual void addRef();
	virtual void release();
	virtual LPCTSTR getActionType() const;
	virtual LPCTSTR getDescription() const;
	virtual ActionInvokerPtr create( const ActionSettingParameter& v_actionSettingParameter ) const;
	virtual const ActionSettingParameter& getDefaultParameter() const;
	virtual bool showEditParameter( HWND v_parent, ActionSettingParameter& ) const;

private:
	LONG refCount_;
	mutable ActionSettingParameter defaultParameter_;
};

#endif
